#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivitySmashEggRewardCFG.h"
std::auto_ptr<M_ActivitySmashEggRewardCFG> M_ActivitySmashEggRewardCFG::msSingleton(nullptr);

int M_ActivitySmashEggRewardCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySmashEggRewardCFGData* M_ActivitySmashEggRewardCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivitySmashEggRewardCFGData>& M_ActivitySmashEggRewardCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySmashEggRewardCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivitySmashEggRewardCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySmashEggRewardCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mEggType = element->IntAttribute("EggType");
		data.mRewardId = element->IntAttribute("RewardId");
		data.mRewardCount = element->IntAttribute("RewardCount");
		data.mWeight = element->IntAttribute("Weight");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivitySmashEggRewardCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySmashEggRewardCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivitySmashEggRewardCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivitySmashEggRewardCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivitySmashEggRewardCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "EggType", data.mEggType);
		LuaCfgHelper::readInt(L, "RewardId", data.mRewardId);
		LuaCfgHelper::readInt(L, "RewardCount", data.mRewardCount);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivitySmashEggRewardCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySmashEggRewardCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivitySmashEggRewardCFG* M_ActivitySmashEggRewardCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySmashEggRewardCFG());
	}
	return msSingleton.get();
}

void M_ActivitySmashEggRewardCFG::Release()
{
	msSingleton.reset(nullptr);
}
